Index: boost/config/stdlib/stlport.hpp
===================================================================
--- boost/config/stdlib/stlport.hpp	(revision 48687)
+++ boost/config/stdlib/stlport.hpp	(working copy)
@@ -127,7 +127,13 @@
          || defined(_STLP_USE_OWN_NAMESPACE)) \
       && (defined(__STL_VENDOR_GLOBAL_CSTD) || defined (_STLP_VENDOR_GLOBAL_CSTD))
 #     define BOOST_NO_STDC_NAMESPACE
-#     define BOOST_NO_EXCEPTION_STD_NAMESPACE
+
+// stlport bundled with sun-5.9 on Linux correctly puts all type_info
+// into the std namespace, i.e. don't define this macro with Sun's stlport under Linux
+#     if (!defined(__SUNPRO_CC) || (defined(__SUNPRO_CC) && !defined(__linux)))
+#       define BOOST_NO_EXCEPTION_STD_NAMESPACE
+#     endif
+
 #  endif
 #elif defined(__BORLANDC__) && __BORLANDC__ < 0x560
 // STLport doesn't import std::abs correctly:
